lv.lumii.layoutengine.flowLayout.horizontalOrdering.pqtree

## Class CNode<T>

- java.lang.Object
- - lv.lumii.layoutengine.flowLayout.horizontalOrdering.pqtree.PQTreeNode<T>
  - - lv.lumii.layoutengine.flowLayout.horizontalOrdering.pqtree.CNode<T>

- Type Parameters:
    `T` - object type

      public class CNode<T>
      extends PQTreeNode<T>

  This class implements C-type node for PQ-tree data structure.

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `CNode(PQTreeNode<T> parent, T o, PQTree<T> tree)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `PQTreeNode<T>` | `getMaxMinSeq()` This method is used for node ordering in algorithm second phase when moving backwards over layers.
    `T` | `getObject()` This method gets object associated with this c-node.
    `java.lang.String` | `getTestValue()` This method returns string value that will represent this node for more comfortable testing.
    `int` | `getType()` This method returns int value to represent this node type.
    `char` | `getTypeChar()` This method returns char that represents this node type.
    `PQTreeNode<T>` | `process(boolean isRoot)` This method performs all transformations with this node.
    `void` | `setEmpty()` This method sets this node as empty.
    `void` | `setObject(T o)` This method sets object associated with this c-node.

    - ### Methods inherited from class lv.lumii.layoutengine.flowLayout.horizontalOrdering.pqtree.PQTreeNode

      `addChild, addChild, clearChildList, getChildIterator, getChildList, getLevel, getMaxSeq, getMinSeq, getParent, getPertQChildrenCount, getTree, isFull, isPertinent, isVisited, removeChild, setLevel, setMaxSeq, setMinSeq, setParent, setParent, setParent, setParent, setTree, setVisited, toString, update`

    - ### Methods inherited from class java.lang.Object

      `equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### CNode

          public CNode(PQTreeNode<T> parent,
                       T o,
                       PQTree<T> tree)

  - ### Method Detail

    - #### getObject

          public T getObject()

      This method gets object associated with this c-node.
      Returns:
        associated object.

    - #### setObject

          public void setObject(T o)

      This method sets object associated with this c-node.
      Parameters:
        `o` - new object.

    - #### getType

          public int getType()

      This method returns int value to represent this node type. Node type is `PQTree.CNODE`
      Specified by:
        `getType` in class `PQTreeNode<T>`
      Returns:
        integer type value. Types are coded as:
    - `PQTree.CNODE`,
    - `PQTree.QNODE`,
    - `PQTree.PNODE`.
      See Also:
        `PQTree`

    - #### process

          public PQTreeNode<T> process(boolean isRoot)

      This method performs all transformations with this node.
      Specified by:
        `process` in class `PQTreeNode<T>`
      Parameters:
        `isRoot` - boolean value whether this is pertinent tree root node.
      Returns:
        boolean value that represents successful transformation.

    - #### setEmpty

          public void setEmpty()

      This method sets this node as empty.
      Overrides:
        `setEmpty` in class `PQTreeNode<T>`

    - #### getTestValue

          public java.lang.String getTestValue()

      This method returns string value that will represent this node for more comfortable testing.
      Overrides:
        `getTestValue` in class `PQTreeNode<T>`
      Returns:
        string value that represents this node.

    - #### getTypeChar

          public char getTypeChar()

      This method returns char that represents this node type.
      Specified by:
        `getTypeChar` in class `PQTreeNode<T>`
      Returns:
        char.

    - #### getMaxMinSeq

          public PQTreeNode<T> getMaxMinSeq()

      This method is used for node ordering in algorithm second phase when moving backwards over layers.
      Specified by:
        `getMaxMinSeq` in class `PQTreeNode<T>`
      Returns:
        next node to process.